#include "ConditionGatherer.h"

ConditionGatherer::ConditionGatherer()
  : m_runStopType(""),
    m_runStopValue(0)
{
    std::cerr << "ConditionGatherer created\n";
}

ConditionGatherer::~ConditionGatherer()
{
    std::cerr << "ConditionGatherer deleted\n";
}

void ConditionGatherer::init(int index, int modNum, conList* cList)
{
    std::cerr << "ConditionGatherer::init\n";
    Condition::init(cList);

    std::string val;
    int ival;
    neunetParams neunetParams;    

    setPrefixStopCond();
    if ( find("type", &val) ) {
	std::cerr << "runStopCondition type:" << val << std::endl;
	m_runStopType = val;
    } 
    
    if ( m_runStopType == "T0") {
	if ( find("value", &ival) ) {
	    std::cerr << "runStopCondition value:" << ival << std::endl;
	    m_runStopValue = ival;
	} 
    }

    for(int i = 0; i < modNum; i++) {
	setPrefixLld(index, i);
	//clear();
	params(i);
    }

    std::cerr << "m_neunetsParams.size():" 
	      << m_neunetsParams.size() << std::endl;

    // for debug
    //print();
}

void ConditionGatherer::setPrefixStopCond() {

    std::string myprefix = "common_Gatherer_runStopCondition_";
    std::cerr << "prefix:" << myprefix << std::endl;
    Condition::setPrefix(myprefix);
}

void ConditionGatherer::setPrefixLld(int index, int modNo) {

    std::stringstream ss_index, ss_modno;
    ss_index << index;
    ss_modno << modNo;
    std::string daqid = ss_index.str();
    std::string daq = "daq";
    std::string mod = "module";
    std::string modno = ss_modno.str();
    std::string del = "_";

    std::string prefix = daq + del + daqid + del + mod + del + modno + del;

    std::cerr << "prefix:" << prefix << std::endl;
    Condition::setPrefix(prefix);
}

/*
void ConditionGatherer::setModuleNum(int modNum)
{
    m_modNumber = modNum;
}
*/

void ConditionGatherer::clear()
{

}


void ConditionGatherer::params()
{
}

void ConditionGatherer::params(int modNo)
{
    bool isValidParams = true;
    neunetParams neunetParams;
    neunetParams.modNo = modNo;

    neunetParams.runStopType  = m_runStopType;
    neunetParams.runStopValue = m_runStopValue;

    unsigned val;
    if ( find("lld", &val) ) {
	neunetParams.lld = val;
	std::cerr << "lld:" << val << std::endl;
    } 
    else {
	isValidParams = false;
	std::cerr << "can not find LLD" << std::endl;
    }
    if ( find("minTof", &val) ) {
	neunetParams.minTof = val;
	std::cerr << "minTof:" << val << std::endl;
    }
    else {
	isValidParams = false;
	std::cerr << "can not find MIN TOF" << std::endl;
    }
    if ( find("maxTof", &val) ) {
	neunetParams.maxTof = val;
	std::cerr << "maxTof:" << val << std::endl;
    }
    else {
	isValidParams = false;
	std::cerr << "can not find MAX TOF" << std::endl;
    }

    if(isValidParams) {
	std::cerr << "### found\n";
	m_neunetsParams.push_back(neunetParams);
    }
}

/*
void ConditionGatherer::print()
{
	cout << "* ConditionGatherer::print()_start" << endl;
	
	cout << "* ConditionGatherer::print()_end" << endl;
}

void ConditionGatherer::printVector(std::string name, std::vector<UInt4Pair > value)
{
	cout << name << ":" << endl;
	

}
*/

