#ifndef CONDITION_GATHERER_H
#define CONDITION_GATHERER_H

#include <string>
#include "Condition.h"

struct neunetParams
{
    std::string runStopType;
    long long runStopValue;
    int modNo;
    unsigned lld;
    unsigned minTof;
    unsigned maxTof;
};

typedef struct neunetParams neunetParams;

typedef vector< neunetParams > neunetsParams;

class ConditionGatherer : public Condition
{
	public:
		ConditionGatherer();
		virtual ~ConditionGatherer();
	
	public:
		void init(int index, int modNum, conList* cList);
		void setPrefixStopCond();
		void setPrefixLld(int index, int modNo);
		//void setModuleNum(int modNum);
 	
	private:
		void clear();
		void params();
		void params(int modNo);
		
		//void print();
		//void printVector(std::string name, std::vector<UInt4Pair> value);
	
	public:
		neunetsParams m_neunetsParams;
       private:
		std::string m_runStopType;
		long long m_runStopValue;
};
#endif

