#include "ConditionMonitor.h"

ConditionMonitor::ConditionMonitor() {}
ConditionMonitor::~ConditionMonitor() {}

bool ConditionMonitor::getParam(std::string prefix, monitorParam* monitorParam)
{
	setPrefix(prefix);
	unsigned int tof_min;
	unsigned int tof_max;
	unsigned int num_of_tof_bin;
	unsigned int num_of_pixel_per_psd;
	unsigned int monitor_update_rate;
	std::string histogramTitle;

	if (find("tof_min", &tof_min)) {
		monitorParam->tof_min = tof_min;
	}
	else {
		std::cerr << prefix + " tof_min not fould" << std::endl;
		return false;
	}

	if (find("tof_max", &tof_max)) {
		monitorParam->tof_max = tof_max;
	}
	else {
		std::cerr << prefix + " tof_max not fould" << std::endl;
		return false;
	}

	if (find("num_of_tof_bin", &num_of_tof_bin)) {
		monitorParam->num_of_tof_bin = num_of_tof_bin;
	}
	else {
		std::cerr << prefix + " num_of_tof_bin not fould" << std::endl;
		return false;
	}

	if (find("num_of_pixel_per_psd", &num_of_pixel_per_psd)) {
		monitorParam->num_of_pixel_per_psd = num_of_pixel_per_psd;
	}
	else {
		std::cerr << prefix + " num_of_pixel_per_psd not fould" << std::endl;
		return false;
	}

	if (find("monitor_update_rate", &monitor_update_rate)) {
		monitorParam->monitor_update_rate = monitor_update_rate;
	}
	else {
		std::cerr << prefix + " monitor_update_rate not fould" << std::endl;
		return false;
	}

	if (find("histogramTitle", &histogramTitle)) {
		monitorParam->histogramTitle = histogramTitle;
	}
	else {
		std::cerr << prefix + " histogramTitle not fould" << std::endl;
		return false;
	}

	return true;
}

bool ConditionMonitor::initialize(std::string filename)
{
	if (m_json2ConList.makeConList(filename, &m_conListMonitor) == false) {
		std::cerr << "### ERROR: Fail to read the Condition file "
				  << filename << std::endl;
	}
	init(&m_conListMonitor);
	return true;
}
