#ifndef _CONDITION_MONITOR_H
#define _CONDITION_MONITOR_H 1

#include <string>
#include "Condition.h"

struct monitorParam {
	unsigned int tof_min;
	unsigned int tof_max;
	unsigned int num_of_tof_bin;
	unsigned int num_of_pixel_per_psd;
	unsigned int monitor_update_rate;
	std::string histogramTitle;
};

typedef struct monitorParam monitorParam;

class ConditionMonitor : public Condition {
public:
	ConditionMonitor();
	virtual ~ConditionMonitor();
	bool initialize(std::string filename);
	bool getParam(std::string prefix,  monitorParam* monitorParam);
private:
	Json2ConList m_json2ConList;
	conList      m_conListMonitor;
};

#endif
