#include "ConditionSkeleton.h"

ConditionSkeleton::ConditionSkeleton()
{
    std::cerr << "ConditionSkeleton created\n";
}

ConditionSkeleton::~ConditionSkeleton()
{
    std::cerr << "ConditionSkeleton deleted\n";
}

void ConditionSkeleton::init(int index, int modNum, conList* cList)
{
    std::cerr << "ConditionSkeleton::init\n";
    Condition::init(cList);

    //setModuleNum(modNo);
	
    for(int i = 0; i < modNum; i++) {
	setPrefix(index, i);
	//clear();
	params(i);
    }

    std::cerr << "m_neunetsParams.size():" 
	      << m_neunetsParams.size() << std::endl;

    // for debug
    //print();
}

void ConditionSkeleton::setPrefix(int index, int modNo) {

    std::stringstream ss_index, ss_modno;
    ss_index << index;
    ss_modno << modNo;
    std::string daqid = ss_index.str();
    std::string daq = "daq";
    std::string mod = "module";
    std::string modno = ss_modno.str();
    std::string del = "_";

    std::string prefix = daq + del + daqid + del + mod + del + modno + del;

    std::cerr << "prefix:" << prefix << std::endl;
    Condition::setPrefix(prefix);
}

/*
void ConditionSkeleton::setModuleNum(int modNum)
{
    m_modNumber = modNum;
}
*/

void ConditionSkeleton::clear()
{

}


void ConditionSkeleton::params()
{
}

void ConditionSkeleton::params(int modNo)
{
    bool isValidParams = true;
    neunetParams neunetParams;
    neunetParams.modNo = modNo;

    unsigned val;
    if ( find("lld", &val) ) {
	neunetParams.lld = val;
	std::cerr << "lld:" << val << std::endl;
    } 
    else {
	isValidParams = false;
	std::cerr << "can not find LLD" << std::endl;
    }
    if ( find("minTof", &val) ) {
	neunetParams.minTof = val;
	std::cerr << "minTof:" << val << std::endl;
    }
    else {
	isValidParams = false;
	std::cerr << "can not find MIN TOF" << std::endl;
    }
    if ( find("maxTof", &val) ) {
	neunetParams.maxTof = val;
	std::cerr << "maxTof:" << val << std::endl;
    }
    else {
	isValidParams = false;
	std::cerr << "can not find MAX TOF" << std::endl;
    }

    if(isValidParams) {
	std::cerr << "### found\n";
	m_neunetsParams.push_back(neunetParams);
    }
}

/*
void ConditionSkeleton::print()
{
	cout << "* ConditionSkeleton::print()_start" << endl;
	
	cout << "* ConditionSkeleton::print()_end" << endl;
}

void ConditionSkeleton::printVector(std::string name, std::vector<UInt4Pair > value)
{
	cout << name << ":" << endl;
	

}
*/

