#include "Header.hh"
#include "EventDataToHistogramBase.hh"
#include "GnuplotInterface.hh"
#include "StringTools.hh"
#include "GslHistogram.hh"

#ifndef EVENTDATATOHISTOGRAMEMULATOR
#define EVENTDATATOHISTOGRAMEMULATOR

class EventDataToHistogramEmulator : public EventDataToHistogramBase
{
public:
	EventDataToHistogramEmulator(
		string MaskFileName,
		Double tof_min,
		Double tof_max,
		UInt4 num_of_tof_bin,
		UInt4 num_of_psd_per_module,
		UInt4 num_of_pixel_per_psd,
		UInt4 total_module_num
	);
	virtual ~EventDataToHistogramEmulator();

	void SetParam(
			string MaskFileName,
			Double tof_min,
			Double tof_max,
			UInt4 num_of_tof_bin,
			UInt4 num_of_psd_per_module,
			UInt4 num_of_pixel_per_psd,
			UInt4 total_module_num
	);
	virtual UInt4 PutPsdId( UInt4 DaqChannel, UInt4 module, UInt4 psd);
	virtual UInt4 PutPsdId( UInt4 DaqChannel, UInt4 module, UInt4 psd, UInt4 modNo);
	virtual UInt4 PutPixelId(UInt4 PsdId, UInt4 PixelPosition);
	void	 	  Increment(UInt4 Channel, UChar* data, UInt4 size);
	void		  Increment(UInt4 Channel, UChar* data, UInt4 size, UInt4 modNo);
	void		  Decode_EventData(
					UChar *data,
					UInt4 *module_num,
					UInt4 *psd_num,
					UInt4 *k,
					UInt4 *ph_l,
					UInt4 *ph_r,
					UInt4 *tof
				  );
	void		  Decode_T0Data( UChar *data, UInt4 *CrateId, UInt8 *PulseId );

private:
  UInt4			m_num_of_psd_per_module;
  UInt4			m_num_of_pixel_per_psd;
  Double	   *m_tof_bin; 				// to delete in the destructor;
};

#endif
